MODULE	Col1 ;

(*=============================================================================
   ASIGNATURA	: Programacion de Computadores 2
   OBJETIVO	: TAD cola no generico
   AUTOR	: Andres Gomez Casanova
   FECHA	: Marzo 28, 2002
=============================================================================*)


(*---------------------------------------------------------------------------*)
(* TIPOS *)
TYPE
					(* Estructura de la cola *)
	Tapnodo	= POINTER TO Tnodo ;
	Tnodo	= RECORD
		datos	: CHAR ;	(* Datos *)
		sig	: Tapnodo ;	(* Siguiente nodo *)
	END ;
	Tcola*	= Tapnodo ;		(* Cabeza de la cola *)

(*---------------------------------------------------------------------------*)
(* DEFINICION E IMPLEMENTACION DE LOS SUBPROGRAMAS *)
(*-----------------------------------------------------------------------------
   PROCEDIMIENTO crearCol (SAL c : Tcola)
-------------------------------------------------------------------------------
   OBJ		: Crear una cola vacia
   PRE		: VERDADERO
   POS		: c de tipo Tcola, apuntado a ella misma
-----------------------------------------------------------------------------*)
PROCEDURE crearCol* (VAR c : Tcola) ;

BEGIN
	NEW (c) ;
	c^.sig := c ;
END	crearCol ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO encolarCol (ENT/SAL c : Tcola, ENT tipo : CARACTER)
-------------------------------------------------------------------------------
   OBJ		: Adicionar un elemento en la cola en la ltima posicion
   PRE		: VERDADERO
   POS		: c de tipo Tcola, con cola = cola + 1
-----------------------------------------------------------------------------*)
PROCEDURE encolarCol* (VAR c : Tcola ; tipo : CHAR) ;

VAR
	nuevo	: Tapnodo ;		(* nodo cola *)

BEGIN
	NEW (nuevo) ;			(* Nuevo nodo *)
	nuevo^.datos := tipo ;		(* Agrega dato *)
	nuevo^.sig := c^.sig ;		(* Apunta a vacio *)
	c^.sig := nuevo ;		(* Apunta al nuevo nodo cola *)
	c := nuevo ;			(* Cola de la cola *)
END	encolarCol ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO desencolarCol (ENT/SAL c : Tcola)
-------------------------------------------------------------------------------
   OBJ		: Elimina la cabeza de la cola
   PRE		: c # c^.sig (Cola no vacia)
   POS		: c de tipo Tcola
-----------------------------------------------------------------------------*)
PROCEDURE desencolarCol* (VAR c : Tcola) ;

VAR
	q, r	: Tapnodo ;		(* Nodos de cabeza y vacio  *)

BEGIN
	(*ASSERT (c # c^.sig) ;		*)(* Cola vacia *)
	NEW (q) ;			(* Nodo a vacio *)
	NEW (r) ;			(* Nodo a cabeza *)
	q := c^.sig ;			(* Vacio *)
	r := q^.sig ;			(* Cabeza *)
	q^.sig := r^.sig ;		(* Elimina cabeza *)
	IF (q = q^.sig) THEN		(* Cola vacia *)
		c := q ;
	END ;
END	desencolarCol ;


(*-----------------------------------------------------------------------------
   FUNCION esVaciaCol* (ENT c : Tcola) : BOOLEANO
-------------------------------------------------------------------------------
   OBJ		: Muestra si la cola es vacia
   PRE		: VERDADERO
   POS		: TRUE si es vacia, FALSE si tiene al menos un elemento
-----------------------------------------------------------------------------*)
PROCEDURE esVaciaCol* (c : Tcola) : BOOLEAN ;

BEGIN
	RETURN (c = c^.sig) ;		(* Retorna si apunta a ella misma *)
END	esVaciaCol ;


(*-----------------------------------------------------------------------------
   FUNCION infoCol (ENT c : Tcola) : CARACTER
-------------------------------------------------------------------------------
   OBJ		: Retorna el dato de la cabeza de la cola
   PRE		: VERDADERO
   POS		: tipo de tipo CARACTER
-----------------------------------------------------------------------------*)
PROCEDURE infoCol* (c : Tcola) : CHAR ;

BEGIN
	ASSERT (esVaciaCol (c) = FALSE) ;
					(* Cola vacia *)
	RETURN c^.sig^.sig^.datos ;	(* Retorna el dato de la cabeza *)
END	infoCol ;


END	Col1.
