MODULE	Cola ;

(*=============================================================================
   ASIGNATURA	: Programacion de Computadores 2
   OBJETIVO	: TAD cola encadenado
   AUTOR	: Andres Gomez Casanova
   FECHA	: Mayo 6, 2002
=============================================================================*)


(*---------------------------------------------------------------------------*)
(* ENCABEZADO DE LOS MODULOS (Bibliotecas) *)
IMPORT	Gnri ;


(*---------------------------------------------------------------------------*)
(* TIPOS *)
TYPE
					(* Estructura de la cola *)
	Tapnodo	= POINTER TO Tnodo ;
	Tnodo	= RECORD
		dato	: Gnri.Tgenerico ;	(* Datos *)
		sig	: Tapnodo ;	(* Siguiente nodo *)
	END ;
	Tcola*	= RECORD ;		(* Cabeza de la cola *)
		cabe	: Tapnodo ;
		cola	: Tapnodo ;
	END ;

(*---------------------------------------------------------------------------*)
(* DEFINICION E IMPLEMENTACION DE LOS SUBPROGRAMAS *)
(*-----------------------------------------------------------------------------
   PROCEDIMIENTO crearCol (SAL c : Tcola)
-------------------------------------------------------------------------------
   OBJ		: Crear una cola vacia
   PRE		: VERDADERO
   POS		: c de tipo Tcola c = {}
-----------------------------------------------------------------------------*)
PROCEDURE crearCol* (VAR c : Tcola) ;

BEGIN
	c.cabe := NIL ;
	c.cola := NIL ;
END	crearCol ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO encolarCol (ENT/SAL c : Tcola, ENT tipo : Gnri.Tgenerico)
-------------------------------------------------------------------------------
   OBJ		: Adicionar un elemento en la cola de la cola
   PRE		: VERDADERO
   POS		: c = {x0, x1, x2, ..., tipo}
-----------------------------------------------------------------------------*)
PROCEDURE encolarCol* (VAR c : Tcola ; tipo : Gnri.Tgenerico) ;

VAR
	nuevo	: Tapnodo ;		(* nodo cola *)

BEGIN
	IF (c.cola = NIL) THEN

(* Cola vacia *)
		NEW (c.cola) ;
		c.cola^.dato := tipo ;
		c.cola^.sig := NIL ;
		c.cabe := c.cola ;
	ELSE

(* Cola no vacia *)
		NEW (nuevo) ;
		nuevo^.dato := tipo ;
		nuevo^.sig := NIL ;
		c.cola^.sig := nuevo ;
		c.cola := nuevo ;
	END ;
END	encolarCol ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO desencolarCol (ENT/SAL c : Tcola)
-------------------------------------------------------------------------------
   OBJ		: Elimina la cabeza de la cola
   PRE		: esVaciaCol (c) = FALSE c.cabe # c.cola
   POS		: c = {x1, x2, ..., xn}
-----------------------------------------------------------------------------*)
PROCEDURE desencolarCol* (VAR c : Tcola) ;

BEGIN
	ASSERT (c.cabe # NIL) ;		(* Cola vacia *)
	c.cabe := c.cabe^.sig ;

(* Cola vacia *)
	IF (c.cabe = NIL) THEN
		c.cola := NIL ;
	END ;
END	desencolarCol ;


(*-----------------------------------------------------------------------------
   FUNCION esVaciaCol* (ENT c : Tcola) : BOOLEANO
-------------------------------------------------------------------------------
   OBJ		: Muestra si la cola es vacia
   PRE		: VERDADERO
   POS		: TRUE si es vacia, FALSE si tiene al menos un elemento
-----------------------------------------------------------------------------*)
PROCEDURE esVaciaCol* (c : Tcola) : BOOLEAN ;

BEGIN
	IF (c.cabe = NIL) THEN
		RETURN TRUE ;
	ELSE
		RETURN FALSE
	END ;
END	esVaciaCol ;


(*-----------------------------------------------------------------------------
   FUNCION infoCol (ENT c : Tcola, SAL tipo : Gnri.Tgenerico)
-------------------------------------------------------------------------------
   OBJ		: Devuelve el dato de la cabeza de la cola
   PRE		: esVaciaCol (c) = FALSE
   POS		: tipo = x0
-----------------------------------------------------------------------------*)
PROCEDURE infoCol* (c : Tcola ; VAR tipo : Gnri.Tgenerico) ;

BEGIN
	ASSERT (esVaciaCol (c) = FALSE) ;(* Cola vacia *)
	tipo := c.cabe^.dato ;	(* dato de la cabeza *)
END	infoCol ;


END	Cola.
