MODULE	Date ;

(*=============================================================================
   ASIGNATURA	: Programacion de Computadores 2
   OBJETIVO	: Validar y convertir fechas
   AUTOR	: Andres Gomez Casanova
   FECHA	: Mayo 4, 2002
=============================================================================*)


(*---------------------------------------------------------------------------*)
(* ENCABEZADO DE LOS MODULOS (Bibliotecas) *)
IMPORT	Tipo ;


(*---------------------------------------------------------------------------*)
(* CONSTANTES *)
CONST
	ACTUAL	= 2002 ;


(*---------------------------------------------------------------------------*)
(* DEFINICION E IMPLEMENTACION DE LOS SUBPROGRAMAS *)
(*-----------------------------------------------------------------------------
   PROCEDIMIENTO meses (ENT mes : ARREGLO DE CARACTER, ENT/SAL fecha : Tipo.Tfecha,
		      SAL tipo : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Analiza un vector mes y lo convierte a numero
   PRE		: mes = ARREGLO
   POS		: fecha.mes = ENTERO, error = fecha invalida
-----------------------------------------------------------------------------*)
PROCEDURE meses* (mes : ARRAY OF CHAR ; VAR fecha : Tipo.Tfecha ; VAR tipo : INTEGER) ;

BEGIN
(* Si el arreglo es igual que al mes, asigna un numero a datos *)
	IF (mes = "Jan") THEN
		fecha.mes := 1 ;
	ELSIF (mes = "Feb") THEN
		fecha.mes := 2 ;
	ELSIF (mes = "Mar") THEN
		fecha.mes := 3 ;
	ELSIF (mes = "Apr") THEN
		fecha.mes := 4 ;
	ELSIF (mes = "May") THEN
		fecha.mes := 5 ;
	ELSIF (mes = "Jun") THEN
		fecha.mes := 6 ;
	ELSIF (mes = "Jul") THEN
		fecha.mes := 7 ;
	ELSIF (mes = "Aug") THEN
		fecha.mes := 8 ;
	ELSIF (mes = "Sep") THEN
		fecha.mes := 9 ;
	ELSIF (mes = "Oct") THEN
		fecha.mes := 10 ;
	ELSIF (mes = "Nov") THEN
		fecha.mes := 11 ;
	ELSIF (mes = "Dec") THEN
		fecha.mes := 12 ;
	ELSE
		tipo := 1 ;
	END ;
END	meses ;


(*-----------------------------------------------------------------------------
   FUNCION validar (ENT fecha : Tipo.Tfecha) : BOOLEANO
-------------------------------------------------------------------------------
   OBJ		: Valida si la fecha entrada es correcta
   PRE		: fecha = Tipo.Techa (agno desde 1980 hasta el presente)
   POS		: TRUE si es correcta, FALSE si no lo es
-----------------------------------------------------------------------------*)
PROCEDURE validar* (fecha : Tipo.Tfecha) : BOOLEAN ;

BEGIN
(* Fecha fuera del rango *)
	IF (fecha.ano < 1980) OR (fecha.ano > ACTUAL) THEN
		RETURN FALSE ;
	ELSIF (fecha.dia < 1) OR (fecha.dia > 31) THEN
		RETURN FALSE ;
	ELSIF (fecha.mes < 1) OR (fecha.mes > 12) THEN
		RETURN FALSE ;

(* Fecha dentro del rango que concuerda *)
	ELSE

(* Abril, Junio, Septiembre y Noviembre *)
		IF (fecha.mes = 4) OR (fecha.mes = 6) OR (fecha.mes = 9)
		      OR (fecha.mes = 11) THEN
			IF (fecha.dia = 31) THEN
				RETURN FALSE ;
			ELSE
				RETURN TRUE ;
			END ;

(* Febrero *)
		ELSIF (fecha.mes = 2) THEN
			IF (fecha.dia > 29) THEN
				RETURN FALSE ;

(* Ao bisiesto *)
			ELSIF (fecha.ano MOD 4 # 0) & (fecha.dia = 29) THEN
				RETURN FALSE ;
			ELSE
				RETURN TRUE ;
			END ;
(* Enero, Marzo, Mayo, Julio, Agosto, Octubre y Diciembre *)
		ELSE	
			RETURN TRUE ;
		END ;
	END ;
END	validar ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO orden (ENT/SAL fecha1, fecha2 : Tipo.Tfecha)
-------------------------------------------------------------------------------
   OBJ		: Ordena dos fecha dadas
   PRE		: validar (fecha1) = TRUE, validar (fecha2) = TRUE
   POS		: fecha1 antes que fecha2
-----------------------------------------------------------------------------*)
PROCEDURE orden* (VAR fecha1, fecha2 : Tipo.Tfecha) ;
VAR
	temp	: Tipo.Tfecha ;		(* Fecha temporal *)
BEGIN
	IF (fecha2.ano < fecha1.ano) THEN
		temp.dia := fecha2.dia ;
		temp.mes := fecha2.mes ;
		temp.ano := fecha2.ano ;
		fecha2.dia := fecha1.dia ;
		fecha2.mes := fecha1.mes ;
		fecha2.ano := fecha1.ano ;
		fecha1.dia := temp.dia ;
		fecha1.mes := temp.mes ;
		fecha1.ano := temp.ano ;
	END ;
	IF (fecha2.mes < fecha1.mes) & (fecha2.ano = fecha1.ano) THEN
		temp.dia := fecha2.dia ;
		temp.mes := fecha2.mes ;
		fecha2.dia := fecha1.dia ;
		fecha2.mes := fecha1.mes ;
		fecha1.dia := temp.dia ;
		fecha1.mes := temp.mes ;
	END ;
	IF (fecha2.dia < fecha1.dia) & (fecha2.ano = fecha1.ano)
	      & (fecha1.mes = fecha2.mes) THEN
		temp.dia := fecha2.dia ;
		fecha2.dia := fecha1.dia ;
		fecha1.dia := temp.dia ;
	END ;
END	orden;


END	Date.
