MODULE	Inte ;

(*=============================================================================
   ASIGNATURA	: Programacion de Computadores 2
   OBJETIVO	: Mostrar la interfaz del proyecto
   AUTOR	: Andres Gomez Casanova
   FECHA	: Abril 26, 2002
=============================================================================*)


(*---------------------------------------------------------------------------*)
(* ENCABEZADO DE LOS MODULOS (Bibliotecas) *)
IMPORT	In, Out, Tipo, Date ;


(*---------------------------------------------------------------------------*)
(* DEFINICION E IMPLEMENTACION DE LOS SUBPROGRAMAS *)
(*-----------------------------------------------------------------------------
   PROCEDIMIENTO programa ()
-------------------------------------------------------------------------------
   OBJ		: Muestra la introduccion del programa
   PRE		: VERDADERO
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE programa* () ;

BEGIN
	Out.Ln () ;
	Out.String (" PROYECTO DE PROGRAMACION 2") ;
	Out.Ln () ;
	Out.Ln () ;
	Out.String ("   Analiza el archivo xferlog el cual") ;
	Out.String (" registra las transferencias por FTP") ;
	Out.Ln () ;
END	programa ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO ayuda
-------------------------------------------------------------------------------
   OBJ		: Muestra los parmetros para trabajar con un ejemplo
   PRE		: VERDADERO
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE ayuda* () ;

BEGIN
	Out.Ln () ;
	Out.String ("   Los parametros a digitar para ejecutar el ") ;
	Out.String ("programa son:") ;
	Out.Ln () ;
	Out.String ("     Proy [nombre archivo binario]") ;
	Out.Ln () ;
	Out.Ln () ;
	Out.String ("       nombre archivo binario es donde se va a") ;
	Out.String (" guardar el analisis.") ;
	Out.Ln () ;
	Out.Ln () ;
	Out.String ("     Ejemplo: Proy analisis.bin") ;
	Out.Ln () ;
END	ayuda ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO comando (SAL cadena : Tipo.Tvector, SAL tipo : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Como no se ha digitado cadena muestra que se va a trabajar
		  con cierta cadena, se da la posibilidad de cambiarla o salir.
   PRE		: VERDADERO
   POS		: cadena = Tipo.Tvector donde se va a crear el archivo
		  binario.  tipo = 0 trabajar con la cadena digitada o
		  defecto; 1 salir del programa.
-----------------------------------------------------------------------------*)
PROCEDURE comando* (VAR cadena : Tipo.Tvector ; VAR tipo : INTEGER) ;
VAR
	opcion	: CHAR ;	(* Opcion digitada para crear archivo *)
	enter	: CHAR ;	(* Lee retorno como fin de linea *)
BEGIN
	Out.Ln () ;
	Out.String (" No se ha digitado ningun nombre de archivo.") ;
	Out.Ln () ;
	opcion := "a" ;
	cadena := "binario" ;
	tipo := 0 ;
	WHILE (opcion # "n") & (opcion # "t") DO
		Out.Ln () ;
		Out.String (" El nombre del archivo sera: ") ;
		Out.String (cadena) ;
		Out.Ln () ;
		Out.Ln () ;
		Out.String ("   Desea trabajar con ese nombre (t)") ;
		Out.Ln () ;
		Out.String ("   Desea reemplazarlo (s)") ;
		Out.Ln () ;
		Out.String ("   Desea salir del programa (n)") ;
		Out.Ln () ;
		Out.Ln () ;
		Out.String (" OPCION : ") ;
		In.Char (opcion) ;
		In.Char (enter) ;
		IF (opcion # "s") & (opcion # "n") & (opcion # "t") THEN
			error (4) ;
		END ;
		IF (opcion = "s") THEN
			Out.Ln () ;
			Out.String (" Digite el nombre del archivo: ") ;
			In.Line (cadena) ;
		ELSIF (opcion = "n") THEN
			tipo := 1 ;	(* Finalizar ejecucion *)
		END ;
	END ;
END	comando ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO error (ENT tipo : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Muestra un mensaje de error con la correspondiente
		  explicacin dependiendo del tipo entrado
   PRE		: tipo [1..9] dependiendo el error que corresponda
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE error* (tipo : INTEGER) ;

BEGIN
	Out.Ln () ;
	Out.String (" ERROR! ") ;
	CASE tipo OF
		1 :
			Out.String ("El archivo con ese nombre ya existe ") ;
			Out.String ("o no se puede crear.") ;
			Out.Ln () ;
		|2 :
			Out.String ("El archivo xferlog no se pudo ") ;
			Out.String ("encontrar.") ;
			Out.Ln () ;
		|3 :
			Out.String ("No se puede reconocer el formato del ") ;
			Out.String ("archivo.  Puede contener lineas en") ;
			Out.Ln () ;
			Out.String ("        blanco.") ;
			Out.Ln () ;
		|4 :
			Out.String ("Opcion digitada fuera del rango.") ;
			Out.Ln () ;
		|5 :
			Out.String ("No se puede analizar el archivo debido a ") ;
			Out.String ("que esta vacio.") ;
			Out.Ln () ;
		|6 :
			Out.String ("El usuario digitado no esta en el ") ;
			Out.String ("archivo binario.") ;
			Out.Ln () ;
		|7 :
			Out.String ("La fecha es incorrecta.") ;
			Out.Ln () ;
		|8 :
			Out.String ("No hay registros en ese rango.") ;
			Out.Ln () ;
		|9 :
			Out.String ("La fecha digitada no esta en el ") ;
			Out.String ("archivo binario.") ;
			Out.Ln () ;
	END ;
	Out.Ln () ;
END	error ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO analizando (ENT ruta : ARREGLO DE CARACTER) ;
-------------------------------------------------------------------------------
   OBJ		: Muestra un mensaje mientras analiza el archivo
   PRE		: VERDADERO
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE analizando* (ruta : ARRAY OF CHAR) ;
BEGIN
	Out.Ln () ;
	Out.String ("   El archivo ");
	Out.String (ruta) ;
	Out.String (" esta siendo analizado.") ;
	Out.Ln () ;
	Out.String ("   Por favor espere") ;
END	analizando ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO punto () ;
-------------------------------------------------------------------------------
   OBJ		: Muestra un punto en pantalla
   PRE		: VERDADERO
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE punto* () ;
BEGIN
	Out.String (".") ;
END	punto ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO analizado () ;
-------------------------------------------------------------------------------
   OBJ		: Muestra un mensaje que el archivo ha sido analizado
   PRE		: VERDADERO
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE analizado* () ;
BEGIN
	Out.Ln () ;
	Out.Ln () ;
	Out.String ("   El archivo ha sido analizado.") ;
	Out.Ln () ;
END	analizado ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO menu (SAL opcion : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Muestra el men de opciones y lee la opcin digitada por el
		  usuario
   PRE		: VERDADERO
   POS		: opcion [1..4]
-----------------------------------------------------------------------------*)
PROCEDURE menu* (VAR opcion : INTEGER) ;
BEGIN
	opcion := 0 ;
	Out.Ln () ;
	Out.String (" Menu Principal.");
	Out.Ln () ;
	Out.Ln () ;
	WHILE (opcion < 1) OR (opcion > 5) DO
		Out.String ("   1.  Listado de usuarios que han realizado ") ;
		Out.String ("transferencias.") ;
		Out.Ln () ;
		Out.String ("   2.  Listar datos dada una fecha.") ;
		Out.Ln () ;
		Out.String ("   3.  Ultima transferencia de un usuario dado.") ;
		Out.Ln () ;
		Out.String ("   4.  Listar la informacion un rango de ") ;
		Out.String ("fechas.") ;
		Out.Ln () ;
		Out.String ("   5.  Salir.") ;
		Out.Ln () ;
		Out.Ln () ;
		Out.String ("   OPCION : ") ;
		In.Int (opcion) ;
		IF (opcion < 1) OR (opcion > 5) THEN
			error (4)
		END ;
	END ;
	Out.Ln () ;
END	menu ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO mostrar (ENT vector : ARREGLO DE 8 CHARACTER)
-------------------------------------------------------------------------------
   OBJ		: Muestra un vector y ajusta los espacios en pantalla
   PRE		: vector de 8 posiciones
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE mostrar* (vector : ARRAY OF CHAR) ;

BEGIN
	Out.String ("   ") ;
	Out.String (vector) ;
	Out.Ln () ;
END	mostrar ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO pausa () ;
-------------------------------------------------------------------------------
   OBJ		: Muestra una pausa en la pantalla para visualizar
   PRE		: VERDADERO
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE pausa* () ;
VAR
	enter	: CHAR ;	(* Oprima cualquier tecla *)
BEGIN
	Out.String (" Oprima la tecla enter para continuar.") ;
	In.Char (enter) ;
END	pausa ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO fecha (SAL fecha1, fecha2 : Tipo.Tfecha)
-------------------------------------------------------------------------------
   OBJ		: Lee 2 fechas dadas por el usuario
   PRE		: valor = ENTERO [0..2]
   POS		: fecha1 y fecha2 = Tipo.Tfecha
-----------------------------------------------------------------------------*)
PROCEDURE fecha* (VAR fecha : Tipo.Tfecha ; valor : INTEGER) ;
BEGIN
	Out.Ln () ;
	fecha.dia := 0 ;
	WHILE (fecha.dia = 0) DO
		Out.String ("   Digite la ") ;
		IF (valor = 1) THEN
			Out.String ("primera ") ;
		ELSIF (valor = 2) THEN
			Out.String ("segunda ") ;
		END ;
		Out.String ("fecha (DD/MM/AAAA): ") ;
		Out.Ln () ;
		Out.String ("      Dia: ") ;
		In.Int (fecha.dia) ;
		Out.String ("      Mes: ") ;
		In.Int (fecha.mes) ;
		Out.String ("      Agno: ") ;
		In.Int (fecha.ano) ;
		IF ~Date.validar (fecha) THEN
			error (7) ;
			fecha.dia := 0 ;
		END ;
	END ;
END	fecha ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO submenu (SAL opcion : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Muestra el submenu de fecha
   PRE		: VERDADERO
   POS		: opcion = ENTERO que es la opcion del usuario
-----------------------------------------------------------------------------*)
PROCEDURE submenu* (VAR opcion : INTEGER) ;

BEGIN
	opcion := 0 ;
	Out.Ln () ;
	Out.String ("   Que tipo de informacion quiere saber segun ") ;
	Out.String ("la fecha digitada.") ;
	Out.Ln () ;
	WHILE (opcion = 0) DO
		Out.Ln () ;
		Out.String ("    1.  Usuario que mas realizo transferencias.") ;
		Out.Ln () ;
		Out.String ("    2.  Usuario que menos realizo transferencias.") ;
		Out.Ln () ;
		Out.String ("    3.  Maquina desde la que se hicieron mas") ;
		Out.String (" transferencias.") ;
		Out.Ln () ;
		Out.String ("    4.  Archivo que mas se transfirio.") ;
		Out.Ln () ;
		Out.Ln () ;
		Out.String ("   OPCION: ") ;
		In.Int (opcion) ;
		IF (opcion < 1) OR (opcion > 4) THEN
			error (4) ;
			opcion := 0 ;
		END ;
	END ;
END	submenu ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO solicit (SAL vector : ARREGLO DE CARACTER, ENT tipo : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Solicita un nombre de usuario, un nombre de maquina o
		  un nombre de archivo
   PRE		: tipo=ENTERO, 1 usuario, 2 maquina, 3 archivo
   POS		: usuario maximo de 8 caracteres
-----------------------------------------------------------------------------*)
PROCEDURE solicit* (VAR vector : ARRAY OF CHAR ; tipo : INTEGER) ;

BEGIN
	IF (tipo = 1) THEN
		Out.String ("   Digite el nombre de usuario: ") ;
		In.Line (vector) ;
	ELSIF (tipo = 2) THEN
		Out.String ("   Digite el nombre de la maquina: ") ;
		In.Line (vector) ;
	ELSIF (tipo = 3) THEN
		Out.String ("   Digite el nombre del archivo con la ruta: ") ;
		In.Line (vector) ;
	END ;
END	solicit ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO transf (ENT dato : Tipo.Tdato)
-------------------------------------------------------------------------------
   OBJ		: Muestra en pantalla la ultima transferencia.
   PRE		: vector con la transferencia
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE transf* (dato : Tipo.Tdato) ;
VAR
	i	: INTEGER ;	(* Longitud del archivo *)
BEGIN
	Out.Ln () ;
	Out.String ("   El ultimo archivo transferido por el usuario: ") ;
	Out.String (dato.usuario) ;
	Out.String (" fue: ") ;
	Out.Ln () ;
	Out.String ("      ") ;
	i := 0 ;
	WHILE (dato.archivo[i] # " ") & (i < LEN (dato.archivo)) DO
		Out.Char (dato.archivo[i]) ;
		INC (i) ;
	END ;
(*	Out.String (dato.archivo) ;
*)	Out.Ln () ;
	Out.String ("   el dia ") ;
	Out.Int (dato.fecha.dia, 0) ;
	Out.String ("/") ;
	Out.Int (dato.fecha.mes, 0) ;
	Out.String ("/") ;
	Out.Int (dato.fecha.ano, 4) ;
	Out.String (" a las ") ;
	Out.Int (dato.fecha.hor, 2) ;
	Out.String (":") ;
	Out.Int (dato.fecha.min, 2) ;
	Out.String (":") ;
	Out.Int (dato.fecha.seg, 2) ;
	Out.String (" horas, desde: ") ;
	Out.Ln () ;
	Out.String ("      ") ;
	Out.String (dato.maquina) ;
	Out.Ln () ;
END	transf ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO rango (ENT dato : Tipo.Tdato)
-------------------------------------------------------------------------------
   OBJ		: Muestra los datos del registro
   PRE		: dato = Tipo.Tdato
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE rango* (dato : Tipo.Tdato) ;
VAR
	i	: INTEGER ;	(* Longitud de arreglo *)
BEGIN
	Out.String ("   Fecha: ") ;
	Out.Int (dato.fecha.dia, 2) ;
	Out.String ("/") ;
	Out.Int (dato.fecha.mes, 2) ;
	Out.String ("/") ;
	Out.Int (dato.fecha.ano, 4) ;
	Out.String (" Hora: ") ;
	Out.Int (dato.fecha.hor, 2) ;
	Out.String (":") ;
	Out.Int (dato.fecha.min, 2) ;
	Out.String (":") ;
	Out.Int (dato.fecha.seg, 2) ;
	Out.Ln () ;
	Out.String ("   Usuario: ") ;
	Out.String (dato.usuario) ;
	Out.String (" Maquina: ") ;
	Out.String (dato.maquina) ;
	Out.Ln () ;
	Out.String ("   Archivo: ") ;

(* Muestra el archivo caracter por caracter *)
	i := 0 ;
	WHILE (dato.archivo[i] # 0X) DO
		Out.Char (dato.archivo[i]) ;
		INC (i) ;
	END ;

(* Si el archivo ocupa menos de una linea, aade una en blanco para ajustar *)
	IF (i <= 68) THEN
		Out.Ln () ;
	END ;
	Out.Ln () ;
END	rango ;

(*-----------------------------------------------------------------------------
   PROCEDIMIENTO result (ENT dato : Tipo.Tdato, ENT valor : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Muestra informacion del registro
   PRE		: dato=Tipo.Tdato con la informacion, valor=ENTERO (1 usuario
		  de mas, 2 usuario de menor, 3 maquina de mas, 4 archivo de 
		  mas transferencias)
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE result* (dato : Tipo.Tdato ; valor : INTEGER) ;

BEGIN
	IF (valor = 1) THEN
		Out.String ("   El usuario que realizo mas transferencias el ") ;
		Out.String ("dia ") ;
		Out.Int (dato.fecha.dia, 2) ;
		Out.String ("/") ;
		Out.Int (dato.fecha.mes, 2) ;
		Out.String ("/") ;
		Out.Int (dato.fecha.ano, 4) ;
		Out.String (" fue ") ;
		Out.String (dato.usuario) ;
	ELSIF (valor = 2) THEN
		Out.String ("   El usuario que menos transferencias realizo") ;
		Out.String (" el dia ") ;
		Out.Int (dato.fecha.dia, 2) ;
		Out.String ("/") ;
		Out.Int (dato.fecha.mes, 2) ;
		Out.String ("/") ;
		Out.Int (dato.fecha.ano, 4) ;
		Out.String (" fue ") ;
		Out.String (dato.usuario) ;
	ELSIF (valor = 3) THEN
		Out.String ("   La maquina desde la que se hicieron mas") ;
		Out.String (" transferencias el dia ") ;
		Out.Int (dato.fecha.dia, 2) ;
		Out.String ("/") ;
		Out.Int (dato.fecha.mes, 2) ;
		Out.String ("/") ;
		Out.Int (dato.fecha.ano, 4) ;
		Out.String (" fue") ;
		Out.Ln () ;
		Out.String ("      ") ;
		Out.String (dato.maquina) ;
	ELSIF (valor = 4) THEN
		Out.String ("   El archivo que mas se transfirio el dia ") ;
		Out.Int (dato.fecha.dia, 2) ;
		Out.String ("/") ;
		Out.Int (dato.fecha.mes, 2) ;
		Out.String ("/") ;
		Out.Int (dato.fecha.ano, 4) ;
		Out.String (" fue") ;
		Out.Ln () ;
		Out.String ("      ") ;
		Out.String (dato.archivo) ;
	END ;	
	Out.Ln () ;
END	result ;


PROCEDURE bandera* (tipo : INTEGER) ;
VAR
	enter : CHAR ;
BEGIN
	Out.String (" Bandera: ") ;
	Out.Int (tipo, 0) ;
	In.Char (enter) ;
END bandera ;
END	Inte.
