MODULE	Line ;

(*=============================================================================
   ASIGNATURA	: Programacion de Computadores 2
   OBJETIVO	: Analiza la linea de comando introducida
   AUTOR	: Andres Gomez Casanova
   FECHA	: Abril 26, 2002
=============================================================================*)


(*---------------------------------------------------------------------------*)
(* ENCABEZADO DE LOS MODULOS (Bibliotecas) *)
IMPORT	Tipo, Args, Inte, Streams ;


(*---------------------------------------------------------------------------*)
(* DEFINICION E IMPLEMENTACION DE LOS SUBPROGRAMAS *)
(*-----------------------------------------------------------------------------
   PROCEDIMIENTO archivo (ENT/SAL nombre : Tipo.Tvector, SAL tipo : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Comprueba que el archivo con ese nombre no existe
   PRE		: nombre = Tipo.Tvector
   POS		: nombre = Tipo.Tvector.  Tipo = 0 continuar, 1 salir del
		  programa.
-----------------------------------------------------------------------------*)
PROCEDURE archivo (VAR nombre : Tipo.Tvector ; VAR tipo : INTEGER) ;
VAR
	destino	: Streams.Stream ;	(* Archivo destino *)
BEGIN
	destino := Streams.Create (nombre) ;
	IF (destino = NIL) THEN
		Inte.error (1) ;
		tipo := 1 ;
	ELSE
		Streams.Close (destino) ;
	END ;
END	archivo ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO reconocer (SAL binario : Tipo.Tvector, SAL tipo : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Lee la cadena de lnea de comando que se digita despus del
		  ejecutable.
   PRE		: VERDADERO
   POS		: tipo = 0 continuar; 1 salir del programa.  binario = nombre
		  de archivo a trabajar
-----------------------------------------------------------------------------*)
PROCEDURE reconocer* (VAR binario : Tipo.Tvector ; VAR tipo : INTEGER) ;

BEGIN
	IF (Args.argc = 1) THEN
		tipo := 1 ;	(* Mostrar mensaje de cadena no digitada *)
		Inte.comando (binario, tipo) ;
	ELSE
		Args.GetArg (1, binario) ;
	END ;
	IF (tipo = 0) THEN
		IF (binario = "-?") OR (binario = "-h") OR (binario = "/?") THEN
			Inte.ayuda () ;
			tipo := 1 ;	(* Terminar la ejecucion *)
		ELSE
			archivo (binario, tipo) ;
		END ;
	END ;
END	reconocer ;


END	Line.
