MODULE	Opci ;

(*=============================================================================
   ASIGNATURA	: Programacion de Computadores 2
   OBJETIVO	: Muestrar las opciones e informacion del binario
   AUTOR	: Andres Gomez Casanova
   FECHA	: Abril 26, 2002
=============================================================================*)


(*---------------------------------------------------------------------------*)
(* ENCABEZADO DE LOS MODULOS (Bibliotecas) *)
IMPORT	Inte, Pila, Streams, Tipo, Date, Cola, Strc ;


(*---------------------------------------------------------------------------*)
(* DEFINICION E IMPLEMENTACION DE LOS SUBPROGRAMAS *)
(*-----------------------------------------------------------------------------
   PROCEDIMIENTO leer (ENT archivo : Streams.Stream, SAL dato : Tipo.Tdado)
-------------------------------------------------------------------------------
   OBJ		: Lee el registro del archivo binario
   PRE		: archivo esta abierto
   POS		: dato de tipo Tdato con todas las casillas llenas
-----------------------------------------------------------------------------*)
PROCEDURE leer (archivo : Streams.Stream ; VAR dato : Tipo.Tdato) ;
VAR
	temp	: INTEGER ;		(* Longitud de arreglo escrito *)
	i	: INTEGER ;		(* Contador de lectura *)

BEGIN
(* Inicializa vectores *)
	i := 0 ;
	WHILE (i < Tipo.USU) DO
		dato.usuario[i] := " " ;
		INC (i) ;
	END ;
	i := 0 ;
	WHILE (i < Tipo.MAQ) DO
		dato.maquina[i] := " " ;
		INC (i) ;
	END ;
	i := 0 ;
	WHILE (i < Tipo.ARC) DO
		dato.archivo[i] := " " ;
		INC (i) ;
	END ;

(* Lee el usuario por caracteres *)
	i := 0 ;
	Streams.ReadInt (archivo, temp) ;
	WHILE (i < temp) DO
		Streams.ReadChar (archivo, dato.usuario[i]) ;
		INC (i) ;
	END ;

(* Coloca fin de arreglo *)
	dato.usuario[i] := 0X ;

(* Lee la maquina por caracteres *)
	i := 0 ;
	Streams.ReadInt (archivo, temp) ;
	WHILE (i < temp) DO
		Streams.ReadChar (archivo, dato.maquina[i]) ;
		INC (i) ;
	END ;

(* Coloca fin de arreglo *)
	dato.maquina[i] := 0X ;

(* Lee el archivo por caracteres *)
	i := 0 ;
	Streams.ReadInt (archivo, temp) ;
	WHILE (i < temp) DO
		Streams.ReadChar (archivo, dato.archivo[i]) ;
		INC (i) ;
	END ;

(* Coloca fin de arreglo *)
	dato.archivo[i] := 0X ;

(* Lee la fecha *)
	Streams.ReadInt (archivo, dato.fecha.ano) ;
	Streams.ReadInt (archivo, dato.fecha.mes) ;
	Streams.ReadInt (archivo, dato.fecha.dia) ;
	Streams.ReadInt (archivo, dato.fecha.hor) ;
	Streams.ReadInt (archivo, dato.fecha.min) ;
	Streams.ReadInt (archivo, dato.fecha.seg) ;
END	leer ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO usuarios (ENT binario : Tipo.Tvector)
-------------------------------------------------------------------------------
   OBJ		: Muestra los usuarios que han realizado transferencias
   PRE		: binario = Tipo.Tvector, nombre de archivo donde se ha
		  procesado la informacin.
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE usuarios (binario : Tipo.Tvector) ;
VAR
	pila	: Pila.Tpila ;	 	(* Pila de usuarios analizados *)
	temp	: Pila.Tpila ;	 	(* Pila de analisis *)
	archivo	: Streams.Stream ;	(* Archivo binario *)
	dato	: Tipo.Tdato	;	(* Estructura del archivo *)
	valor	: INTEGER ;		(* Presencia en la pila *)
	vector	: ARRAY Tipo.USU OF CHAR ;(* Comparacion de pila y leido *)
	i	: INTEGER ;		(* Numero de lineas en pantalla *)

BEGIN
(* Abre el archivo binario de donde se analizan los datos *)
	archivo := Streams.Open (binario) ;

(* Crea la pila con la que se comparan los usuarios *)
	Pila.crearPil (pila) ;
	Pila.crearPil (temp) ;

(* Recorre todo el archivo binario *)
	WHILE ~Streams.Eof (archivo) DO

(* Lee los datos del registro del archivo binario *)
		leer (archivo, dato) ;

(* Compara el usuario con los ya analizados dentro de la pila *)
		valor := 0 ;
		WHILE ~Pila.esVaciaPil (pila) DO
			Pila.infoPil (pila, vector) ;

(* Si se encuentra, cambia valor (0 no esta, 1 esta) *)
			IF (vector = dato.usuario) THEN
				valor := 1 ;
			END ;

(* Pasa los datos a otra pila *)
			Pila.apilarPil (temp, vector) ;
			Pila.desapilarPil (pila) ;
		END ;

(* Si no estaba lo adiciona a la pila *)
		IF (valor = 0) THEN
			Pila.apilarPil (pila, dato.usuario) ;
		END ;

(* Revierte la pila *)
		WHILE ~Pila.esVaciaPil (temp) DO
			Pila.infoPil (temp, vector) ;
			Pila.apilarPil (pila, vector) ;
			Pila.desapilarPil (temp) ;
		END ;
	END ;

(* Muestra los datos (usuarios) de la pila *)
	i := 0 ;
	WHILE ~Pila.esVaciaPil (pila) DO
		Pila.infoPil (pila, vector) ;
		Inte.mostrar (vector) ;
		Pila.desapilarPil (pila) ;

(* Muestra una pausa en la pantalla cada 23 lineas *)
		INC (i) ;
		IF (i = 23) THEN
			Inte.pausa () ;
			i := 0 ;
		END ;
	END ;
	Streams.Close (archivo) ;
	Inte.pausa () ;
END	usuarios ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO masomenos (ENT binario : Tipo.Tvector, ENT fecha : Tipo.Tfecha
			    SAL valor : ENTERO, SAL cola : Cola.Tcola,
			    ENT tipo : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Analiza los usuarios dada una fecha y retorna el que hizo mas
   PRE		: binario existe, Date.verificar (fecha) = TRUE
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE masomenos (binario : Tipo.Tvector ; fecha : Tipo.Tfecha ;
		     VAR valor : INTEGER ; VAR cola : Cola.Tcola ;
		     tipo : INTEGER) ;
VAR
	archivo	: Streams.Stream ;	(* Archivo binario *)
	temp	: Tipo.Tdato ;		(* Registro del archivo leido *)
	copia	: Cola.Tcola ;		(* Cola de copia *)
	esta	: INTEGER ;		(* Presencia del usuario en la cola *)
	j	: INTEGER ;		(* Comparacion de contadores de trans *)
	estruct	: Strc.Tdatos ;		(* Estructura de la cola *)
	dato	: Tipo.Tdato ;		(* Resultado *)

BEGIN
(* La fecha no esta en el archivo *)
	valor := 1 ;

(* Abre el archivo binario de donde se analizan los datos *)
	archivo := Streams.Open (binario) ;

(* Crea las colas *)
	Cola.crearCol (cola) ;
	Cola.crearCol (copia) ;

(* Recorre todo el archivo binario *)
	WHILE ~Streams.Eof (archivo) DO

(* Lee los datos del registro del archivo binario *)
		leer (archivo, temp) ;

(* Compara la fecha introducida con la del registro leido *)
		IF (fecha.dia = temp.fecha.dia) & (fecha.mes = temp.fecha.mes)
		   & (fecha.ano = temp.fecha.ano) THEN
			valor := 0 ;

(* Compara el usuario con los de la cola *)
			esta := 1 ;
			WHILE ~Cola.esVaciaCol (cola) DO
				Cola.infoCol (cola, estruct) ;
				IF (tipo = 1) THEN
					Strc.obtenerUsu (estruct, dato.usuario) ;
				ELSIF (tipo = 2) THEN
					Strc.obtenerMaq (estruct, dato.maquina) ;
				ELSIF (tipo = 3) THEN
					Strc.obtenerArc (estruct, dato.archivo) ;
				END ;
				Strc.obtenerCon (estruct, j) ;
				IF (dato.usuario = temp.usuario) & (tipo = 1) THEN
					Strc.modificarCon (estruct, j + 1) ;
					esta := 0 ;
				ELSIF (dato.maquina = temp.maquina) & (tipo = 2) THEN
					Strc.modificarCon (estruct, j + 1) ;
					esta := 0 ;
				ELSIF (dato.archivo = temp.archivo) & (tipo = 3) THEN
					Strc.modificarCon (estruct, j + 1) ;
					esta := 0 ;
				END ;
				Cola.encolarCol (copia, estruct) ;
				Cola.desencolarCol (cola) ;
			END ;

(* Si no esta lo adiciona *)
			IF (esta = 1) THEN
				Strc.crear (estruct) ;
				IF (tipo = 1) THEN
					Strc.modificarUsu (estruct, temp.usuario) ;
				ELSIF (tipo = 2) THEN
					Strc.modificarMaq (estruct, temp.maquina) ;
				ELSIF (tipo = 3) THEN
					Strc.modificarArc (estruct, temp.archivo) ;
				END ;
				Strc.modificarCon (estruct, 1) ;
				Cola.encolarCol (cola, estruct) ;
			END ;

(* Devuelve los datos a la otra cola *)
			WHILE ~Cola.esVaciaCol (copia) DO
				Cola.infoCol (copia, estruct) ;
				Cola.encolarCol (cola, estruct) ;
				Cola.desencolarCol (copia) ;
			END ;
		END ;
	END ;
	Streams.Close (archivo) ;
END	masomenos ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO mayor (ENT binario : Tipo.Tvector, ENT fecha : Tipo.Tfecha)
-------------------------------------------------------------------------------
   OBJ		: Analiza los usuarios dada una fecha y retorna el (los) que
		  mas transferencias hizo (hicieron).
   PRE		: binario existe, Date.verificar (fecha) = TRUE
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE mayor (binario : Tipo.Tvector ; fecha : Tipo.Tfecha) ;
VAR
	valor	: INTEGER ;		(* Presencia de la fecha en binario *)
	cola	: Cola.Tcola ;		(* Cola de usuarios *)
	pila	: Pila.Tpila ;	 	(* Pila de usuarios analizados *)
	dato	: Tipo.Tdato ;		(* Resultado *)
	estruct	: Strc.Tdatos ;		(* Estructura de la cola *)
	j	: INTEGER ;		(* Comparacion de contadores de trans *)
	max	: INTEGER ;		(* Maximo de transferencias *)
	tipo	: INTEGER ;		(* Tipo de analisis *)

BEGIN
(* Tipo de analisis que se va a hacer *)
	tipo := 1 ;

(* Analiza los usuarios en el archivo *)
	masomenos (binario, fecha, valor, cola, tipo) ;

(* Copia la fecha a dato *)
	dato.fecha.dia := fecha.dia ;
	dato.fecha.mes := fecha.mes ;
	dato.fecha.ano := fecha.ano ;

(* Crea la pila con la que se comparan los usuarios *)
	Pila.crearPil (pila) ;

(* La fecha no esta en el archivo binario *)
	IF (valor = 1) THEN
		Inte.error (9) ;
	ELSE

(* Recorre la cola determinando el usuario con mas transferencias *)
		max := 0 ;
		WHILE ~Cola.esVaciaCol (cola) DO
			Cola.infoCol (cola, estruct) ;
			Strc.obtenerCon (estruct, j) ;
			IF (j > max) THEN
				Strc.obtenerUsu (estruct, dato.usuario) ;
				max := j ;
				WHILE ~Pila.esVaciaPil (pila) DO
					Pila.desapilarPil (pila) ;
				END ;
				Pila.apilarPil (pila, dato.usuario) ;
			ELSIF (j = max) THEN
				Strc.obtenerUsu (estruct, dato.usuario) ;
				Pila.apilarPil (pila, dato.usuario) ;
			END ;
			Cola.desencolarCol (cola) ;
		END ;

(* Muestra el usuario con mayor numero de transferencias *)
		WHILE ~Pila.esVaciaPil (pila) DO
			Pila.infoPil (pila, dato.usuario) ;
			Inte.result (dato, 1) ;
			Pila.desapilarPil (pila) ;
		END ;
		Inte.pausa () ;
	END ;
END	mayor ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO menor (ENT binario : Tipo.Tvector, ENT fecha : Tipo.Tfecha)
-------------------------------------------------------------------------------
   OBJ		: Analiza los usuarios dada una fecha y retorna el (los) que
		  menos transferencias hizo (hicieron)
   PRE		: binario existe, Date.verificar (fecha) = TRUE
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE menor (binario : Tipo.Tvector ; fecha : Tipo.Tfecha) ;
VAR
	valor	: INTEGER ;		(* Presencia de la fecha en binario *)
	cola	: Cola.Tcola ;		(* Cola de usuarios *)
	pila	: Pila.Tpila ;	 	(* Pila de usuarios analizados *)
	dato	: Tipo.Tdato ;		(* Resultado *)
	estruct	: Strc.Tdatos ;		(* Estructura de la cola *)
	j	: INTEGER ;		(* Comparacion de contadores de trans *)
	min	: INTEGER ;		(* Maximo de transferencias *)
	esta	: INTEGER ;		(* Presencia de minimo *)
	tipo	: INTEGER ;		(* Tipo de analisis *)

BEGIN
(* Tipo de analisis que se va a hacer *)
	tipo := 1 ;

(* Analiza los usuarios en el archivo *)
	masomenos (binario, fecha, valor, cola, tipo) ;

(* Copia la fecha a dato *)
	dato.fecha.dia := fecha.dia ;
	dato.fecha.mes := fecha.mes ;
	dato.fecha.ano := fecha.ano ;

(* Crea la pila con la que se comparan los usuarios *)
	Pila.crearPil (pila) ;

(* La fecha no esta en el archivo binario *)
	IF (valor = 1) THEN
		Inte.error (9) ;
	ELSE

(* Recorre la cola determinando el usuario con menos transferencias *)
		esta := 0 ;
		WHILE ~Cola.esVaciaCol (cola) DO
			Cola.infoCol (cola, estruct) ;
			Strc.obtenerCon (estruct, j) ;
			IF (esta = 0) THEN
				esta := 1 ;
				min := j ;
			END ;
			IF (j < min) THEN
				Strc.obtenerUsu (estruct, dato.usuario) ;
				min := j ;
				WHILE ~Pila.esVaciaPil (pila) DO
					Pila.desapilarPil (pila) ;
				END ;
				Pila.apilarPil (pila, dato.usuario) ;
			ELSIF (j = min) THEN
				Strc.obtenerUsu (estruct, dato.usuario) ;
				Pila.apilarPil (pila, dato.usuario) ;
			END ;
			Cola.desencolarCol (cola) ;
		END ;

(* Muestra el usuario con mayor numero de transferencias *)
		WHILE ~Pila.esVaciaPil (pila) DO
			Pila.infoPil (pila, dato.usuario) ;
			Inte.result (dato, 2) ;
			Pila.desapilarPil (pila) ;
		END ;
		Inte.pausa () ;
	END ;
END	menor ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO maquinas (ENT binario : Tipo.Tvector, 
			   ENT fecha : Tipo.Tfecha)
-------------------------------------------------------------------------------
   OBJ		: Analiza las maquinas dada una fecha y retorna desde la que se
		  hicieron mas transferencias
   PRE		: binario existe, Date.verificar (fecha) = TRUE
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE maquinas (binario : Tipo.Tvector ; fecha : Tipo.Tfecha) ;
VAR
	valor	: INTEGER ;		(* Presencia de la fecha en binario *)
	cola	: Cola.Tcola ;		(* Cola de maquinas *)
	pila	: Pila.Tpila ;	 	(* Pila de maquinas analizadas *)
	dato	: Tipo.Tdato ;		(* Resultado *)
	estruct	: Strc.Tdatos ;		(* Estructura de la cola *)
	j	: INTEGER ;		(* Comparacion de contadores de trans *)
	max	: INTEGER ;		(* Maximo de transferencias *)
	tipo	: INTEGER ;		(* Tipo de analisis *)

BEGIN
(* Tipo de analisis que se va a hacer *)
	tipo := 2 ;

(* Analiza las maquinas en el archivo *)
	masomenos (binario, fecha, valor, cola, tipo) ;

(* Copia la fecha a dato *)
	dato.fecha.dia := fecha.dia ;
	dato.fecha.mes := fecha.mes ;
	dato.fecha.ano := fecha.ano ;

(* Crea la pila con la que se comparan las maquinas *)
	Pila.crearPil (pila) ;

(* La fecha no esta en el archivo binario *)
	IF (valor = 1) THEN
		Inte.error (9) ;
	ELSE

(* Recorre la cola determinando la maquina con mas transferencias *)
		max := 0 ;
		WHILE ~Cola.esVaciaCol (cola) DO
			Cola.infoCol (cola, estruct) ;
			Strc.obtenerCon (estruct, j) ;
			IF (j > max) THEN
				Strc.obtenerMaq (estruct, dato.maquina) ;
				max := j ;
				WHILE ~Pila.esVaciaPil (pila) DO
					Pila.desapilarPil (pila) ;
				END ;
				Pila.apilarPil (pila, dato.maquina) ;
			ELSIF (j = max) THEN
				Strc.obtenerMaq (estruct, dato.maquina) ;
				Pila.apilarPil (pila, dato.maquina) ;
			END ;
			Cola.desencolarCol (cola) ;
		END ;

(* Muestra la maquina con mayor numero de transferencias *)
		WHILE ~Pila.esVaciaPil (pila) DO
			Pila.infoPil (pila, dato.maquina) ;
			Inte.result (dato, 3) ;
			Pila.desapilarPil (pila) ;
		END ;
		Inte.pausa () ;
	END ;

END	maquinas ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO archivos (ENT binario : Tipo.Tvector,
			   ENT fecha : Tipo.Tfecha)
-------------------------------------------------------------------------------
   OBJ		: Analiza los archivos dada una fecha y retorna el que mas se
		  transfirio
   PRE		: binario existe, Date.verificar (fecha) = TRUE
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE archivos (binario : Tipo.Tvector ; fecha : Tipo.Tfecha) ;
VAR
	valor	: INTEGER ;		(* Presencia de la fecha en binario *)
	cola	: Cola.Tcola ;		(* Cola de archivos *)
	pila	: Pila.Tpila ;	 	(* Pila de archivos analizados *)
	dato	: Tipo.Tdato ;		(* Resultado *)
	estruct	: Strc.Tdatos ;		(* Estructura de la cola *)
	j	: INTEGER ;		(* Comparacion de contadores de trans *)
	max	: INTEGER ;		(* Maximo de transferencias *)
	tipo	: INTEGER ;		(* Tipo de analisis *)

BEGIN
(* Tipo de analisis que se va a hacer *)
	tipo := 3 ;

(* Analiza los archivos en el archivo *)
	masomenos (binario, fecha, valor, cola, tipo) ;

(* Copia la fecha a dato *)
	dato.fecha.dia := fecha.dia ;
	dato.fecha.mes := fecha.mes ;
	dato.fecha.ano := fecha.ano ;

(* Crea la pila con la que se comparan los archivos *)
	Pila.crearPil (pila) ;

(* La fecha no esta en el archivo binario *)
	IF (valor = 1) THEN
		Inte.error (9) ;
	ELSE

(* Recorre la cola determinando el archivo mas transferido *)
		max := 0 ;
		WHILE ~Cola.esVaciaCol (cola) DO
			Cola.infoCol (cola, estruct) ;
			Strc.obtenerCon (estruct, j) ;
			IF (j > max) THEN
				Strc.obtenerArc (estruct, dato.archivo) ;
				max := j ;
				WHILE ~Pila.esVaciaPil (pila) DO
					Pila.desapilarPil (pila) ;
				END ;
				Pila.apilarPil (pila, dato.archivo) ;
			ELSIF (j = max) THEN
				Strc.obtenerArc (estruct, dato.archivo) ;
				Pila.apilarPil (pila, dato.archivo) ;
			END ;
			Cola.desencolarCol (cola) ;
		END ;

(* Muestra el usuario con mayor numero de transferencias *)
		WHILE ~Pila.esVaciaPil (pila) DO
			Pila.infoPil (pila, dato.archivo) ;
			Inte.result (dato, 4) ;
			Pila.desapilarPil (pila) ;
		END ;
		Inte.pausa () ;
	END ;
END	archivos ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO listar (ENT binario : Tipo.Tvector)
-------------------------------------------------------------------------------
   OBJ		: Segn la opcin digitada analiza el archivo, validando la
		  fecha que se introduce.
   PRE		: binario = Tipo.Tvector, nombre de archivo donde se ha
		  procesado la informacin.
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE listar (binario : Tipo.Tvector) ;
VAR
	fecha	: Tipo.Tfecha ;		(* Fecha para el analisis *)
	archivo	: Streams.Stream ;	(* Archivo binario *)
	opcion	: INTEGER ;		(* Opcion del usuario *)
BEGIN
(* Solicita la fecha al usuario *)
	Inte.fecha (fecha, 0) ;

(* Muestra el submenu de fecha *)
	Inte.submenu (opcion) ;

(* Abre el archivo binario donde se analizan los datos *)
	archivo := Streams.Open (binario) ;

(* Ejecuta la operacion correspondiente *)
	CASE opcion OF
		1 :	mayor (binario, fecha) ;
		|2 :	menor (binario, fecha) ;
		|3 :	maquinas (binario, fecha) ;
		|4 :	archivos (binario, fecha) ;
	END ;
END	listar ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO ultima (ENT binario : Tipo.Tvector)
-------------------------------------------------------------------------------
   OBJ		: Muestra la ltima transferencia de un usuario dado
   PRE		: binario = Tipo.Tvector, nombre de archivo donde se ha
		  procesado la informacin.
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE ultima (binario : Tipo.Tvector) ;
VAR
	archivo	: Streams.Stream ;	(* Archivo binario *)
	res	: Tipo.Tdato ;		(* Resultado *)
	dato	: Tipo.Tdato ;		(* Registro del archivo *)
	valor	: INTEGER ;		(* Presencia de usuario en binario *)
	i	: INTEGER ;		(* Contador de posiciones de vector *)
BEGIN
(* El usuario no esta en el registro por defecto *)
	valor := 1 ;

(* Solicita el nombre del usuario *)
	Inte.solicit (res.usuario, 1) ;

(* Abre el archivo binario donde se analizan los datos *)
	archivo := Streams.Open (binario) ;

(* Recorre todo el archivo binario *)
	WHILE ~Streams.Eof (archivo) DO

(* Lee los datos del registro del archivo binario *)
		leer (archivo, dato) ;

(* Compara el usuario introducido con el de binario *)
		IF (dato.usuario = res.usuario) THEN
			valor := 0 ;

(* Copia los datos del binario *)
			i := 0 ;
			WHILE (dato.maquina[i] # 0X) DO
				res.maquina[i] := dato.maquina[i] ;
				INC (i) ;
			END ;
			WHILE (i < Tipo.MAQ - 2) DO
				res.maquina[i] := " " ;
				INC (i) ;
			END ;
			i := 0 ;
			WHILE (dato.archivo[i] # 0X) DO
				res.archivo[i] := dato.archivo[i] ;
				INC (i) ;
			END ;
			WHILE (i < Tipo.ARC - 2) DO
				res.archivo[i] := " " ;
				INC (i) ;
			END ;
			res.fecha.ano := dato.fecha.ano ;
			res.fecha.mes := dato.fecha.mes ;
			res.fecha.dia := dato.fecha.dia ;
			res.fecha.hor := dato.fecha.hor ;
			res.fecha.min := dato.fecha.min ;
			res.fecha.seg := dato.fecha.seg ;
		END ;
	END ;
(* El usuario no esta en el archivo binario *)
	IF (valor = 1) THEN
		Inte.error (6) ;
	ELSE

(* Muestra la ultima transferencia *)
		Inte.transf (res) ;
	END ;
	Streams.Close (archivo) ;
END	ultima ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO rango (ENT binario : Tipo.Tvector)
-------------------------------------------------------------------------------
   OBJ		: Muestra las transferencias realizadas en un rango de fechas
		  validas.
   PRE		: binario = Tipo.Tvector, nombre de archivo donde se ha
		  procesado la informacin.
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE rango (binario : Tipo.Tvector) ;
VAR
	fecha1	: Tipo.Tfecha ;		(* Fecha inferior *)
	fecha2	: Tipo.Tfecha ;		(* Fecha superior *)
	archivo	: Streams.Stream ;	(* Archivo binario *)
	dato	: Tipo.Tdato ;		(* Registro de lectura de binario *)
	i	: INTEGER ;		(* Numero de lineas en pantalla *)
	valor	: INTEGER ;		(* Existencia de registros en rango *)
BEGIN
(* Lee las fechas *)
	valor := 0 ;
	Inte.fecha (fecha1, 1) ;
	Inte.fecha (fecha2, 2) ;

(* Organiza las fechas por orden cronologico *)
	Date.orden (fecha1, fecha2) ;

(* Abre el archivo binario donde se analizan los datos *)
	archivo := Streams.Open (binario) ;

(* Lee hasta el agno anterio *)
	leer (archivo, dato) ;
	WHILE (dato.fecha.ano < fecha1.ano) & ~Streams.Eof (archivo) DO
		leer (archivo, dato) ;
	END ;
(* Lee hasta el mes anterior *)
	WHILE (dato.fecha.ano = fecha1.ano) & (dato.fecha.mes < fecha1.mes)
	      & ~Streams.Eof (archivo) DO
		leer (archivo, dato) ;
	END ;
(* Lee hasta el dia anterior *)
	WHILE (dato.fecha.ano = fecha1.ano) & (dato.fecha.mes = fecha1.mes)
	      & (dato.fecha.dia < fecha1.dia) & ~Streams.Eof (archivo) DO
		leer (archivo, dato) ;
	END ;

(* Muestra registros hasta el agno anterior *)
	i := 0 ;
	WHILE (dato.fecha.ano < fecha2.ano) & ~Streams.Eof (archivo) DO
		Inte.rango (dato) ;
		leer (archivo, dato) ;

(* Muestra una pausa en la pantalla cada 24 lineas *)
		INC (i) ;
		IF (i = 6) THEN
			Inte.pausa () ;
			i := 0 ;
		END ;
		valor := 1 ;
	END ;

(* Muestra registros hasta el mes anterior *)
	WHILE (dato.fecha.ano = fecha2.ano) & (dato.fecha.mes < fecha2.mes)
	      & ~Streams.Eof (archivo) DO
		Inte.rango (dato) ;
		leer (archivo, dato) ;
		INC (i) ;

(* Muestra una pausa en la pantalla cada 24 lineas *)
		IF (i = 6) THEN
			Inte.pausa () ;
			i := 0 ;
		END ;
		valor := 1 ;
	END ;

(* Muestra registros hasta el mismo dia *)
	WHILE (dato.fecha.dia <= fecha2.dia) & (dato.fecha.mes = fecha2.mes)
	      & (dato.fecha.ano = fecha2.ano) & ~Streams.Eof (archivo) DO
		Inte.rango (dato) ;
		leer (archivo, dato) ;

(* Muestra una pausa en la pantalla cada 24 lineas *)
		INC (i) ;
		IF (i = 6) THEN
			Inte.pausa () ;
			i := 0 ;
		END ;
		valor := 1 ;
	END ;


(* Si llego al final del archivo y el que esta en memoria esta en el rango *)
	IF (dato.fecha.ano = fecha2.ano) & (dato.fecha.mes = fecha2.mes)
	      & (dato.fecha.dia <= fecha2.dia) THEN
		Inte.rango (dato) ;
		valor := 1 ;
	ELSIF (dato.fecha.ano = fecha2.ano) & (dato.fecha.mes < fecha2.mes) THEN
		Inte.rango (dato) ;
		valor := 1 ;
	ELSIF (dato.fecha.ano < fecha2.ano) THEN
		Inte.rango (dato) ;
		valor := 1 ;
	END ;

(* Si no hay fechas en el rango dado *)
	IF (valor = 0) THEN
		Inte.error (8) ;
	END ;
	Inte.pausa () ;
	Streams.Close (archivo) ;
END	rango ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO opciones (ENT binario : Tipo.Tvector)
-------------------------------------------------------------------------------
   OBJ		: Segn la opcin digitada, carga el correspondiente
		  procedimiento.  Muestra el men hasta que la opcin salir
		  sea digitada.
   PRE		: binario = Tipo.Tvector, que es el nombre donde se ha hecho
		  el anlisis de xferlog
   POS		: VERDADERO
-----------------------------------------------------------------------------*)
PROCEDURE opciones* (binario : Tipo.Tvector) ;
VAR
	opcion	: INTEGER ; 		(* Opcion a analizar *)
BEGIN
(* Mensaje de archivo analizado *)
	Inte.analizado () ;

(* Realiza operaciones *)
	opcion := 0 ;
	WHILE (opcion # Tipo.SALIR) DO
		Inte.menu (opcion) ;

(* No se hace con case, ya que al compilar falla oberon *)
		IF (opcion = 1) THEN
			usuarios (binario) ;
		ELSIF (opcion = 2) THEN
			listar (binario) ;
		ELSIF (opcion = 3) THEN
			ultima (binario) ;
		ELSIF (opcion = 4) THEN
			rango (binario) ;
		ELSE
		END ;
	END ;
END	opciones ;


END	Opci.
