MODULE	Pila ;

(*=============================================================================
   ASIGNATURA	: Programacion de Computadores 1
   OBJETIVO	: Manejo de Pila, variando la estructura del vector
   AUTOR	: Andres Gomez Casanova
   FECHA	: Marzo 28, 2002
=============================================================================*)


(*---------------------------------------------------------------------------*)
(* CONSTANTES *)
CONST
	MAX	= 241 ;


(*---------------------------------------------------------------------------*)
(* TIPOS *)
TYPE
					(* Estructura de la pila *)
	Tapnodo	= POINTER TO Tnodo ;
	Tnodo	= RECORD		(* Elemento de pila *)
		datos	: ARRAY MAX OF CHAR ;	(* Dato *)
		sig	: Tapnodo ;	(* Encadenamiento *)
	END ;
	Tpila*	= Tapnodo ;


(*---------------------------------------------------------------------------*)
(* DEFINICION E IMPLEMENTACION DE LOS SUBPROGRAMAS *)
(*-----------------------------------------------------------------------------
   PROCEDIMIENTO crearPil (SAL pila : Tpila)
-------------------------------------------------------------------------------
   OBJ		: Crear una pila
   PRE		: VERDADERO
   POS		: pila de tipo Tpila apuntando a NIL
-----------------------------------------------------------------------------*)
PROCEDURE crearPil* (VAR pila : Tpila) ;
BEGIN
	pila := NIL ;		(* Asigna pila como nula *)
END	crearPil ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO apilarPil (ENT/SAL p : Tpila, ENT tipo : ARREGLO 8 DE CARACTER)
-------------------------------------------------------------------------------
   OBJ		: Adiciona un elemento a la pila
   PRE		: VERDADERO
   POS		: Pila de tipo Tpila, apuntando el nuevo a NIL
-----------------------------------------------------------------------------*)
PROCEDURE apilarPil* (VAR p : Tpila ; tipo : ARRAY OF CHAR) ;

VAR
	nodo	: Tapnodo ;		(* Elemento a adicionar *)
	i	: INTEGER ;

BEGIN
	NEW (nodo) ;			(* Crea un apuntador *)
	i := 0 ;
	WHILE (i < LEN (tipo)) DO
		nodo^.datos[i] := tipo[i] ;	(* Asigna el dato *)
		INC (i) ;
	END ;
	nodo^.sig := p ;		(* Nuevo nodo como cabeza *)
	p := nodo ;			(* Asigna p como tope *)
END	apilarPil ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO desapilarPil (ENT/SAL p : Tpila)
-------------------------------------------------------------------------------
   OBJ		: Elimina dato tope de la pila
   PRE		: Pila no vacia
   POS		: Pila de tipo Tpila, apuntando el anterior a NIL
-----------------------------------------------------------------------------*)
PROCEDURE desapilarPil* (VAR p : Tpila) ;

BEGIN
	p := p^.sig ;			(* Apunta al nuevo tope *)
END	desapilarPil ;


(*-----------------------------------------------------------------------------
   FUNCION esVaciaPil (ENT p : Tpila) : LOGICO
-------------------------------------------------------------------------------
   OBJ		: Muestra si la pila es vacia
   PRE		: VERDADERO
   POS		: TRUE si es vacia, FALSE si tiene algun elemento
-----------------------------------------------------------------------------*)
PROCEDURE esVaciaPil* (p : Tpila) : BOOLEAN ;

BEGIN
	RETURN (p = NIL) ;		(* Retorna el estado de la pila *)
END	esVaciaPil ;


(*-----------------------------------------------------------------------------
   FUNCION infoPil (ENT p : Tpila, SAL tipo : ARREGLO 8 DE CARACTER)
-------------------------------------------------------------------------------
   OBJ		: Retorna la informacion del tope de la pila
   PRE		: VERDADERO
   POS		: Tipo de tipo entero
-----------------------------------------------------------------------------*)
PROCEDURE infoPil* (p : Tpila ; VAR tipo : ARRAY OF CHAR ) ;
VAR
	i	: INTEGER ;

BEGIN
	ASSERT (esVaciaPil (p) = FALSE) ;
	i := 0 ;
	WHILE (i < LEN (tipo)) DO
		tipo[i] := p^.datos[i] ;	(* Asigna el dato *)
		INC (i) ;
	END ;
END	infoPil ;


END	Pila.
