MODULE	Strc ;

(*=============================================================================
   ASIGNATURA	: Programacion de Computadores 2
   OBJETIVO	: Estructura para genericidad
   AUTOR	: Andres Gomez Casanova
   FECHA	: Mayo 6, 2002
=============================================================================*)


(*---------------------------------------------------------------------------*)
(* ENCABEZADO DE LOS MODULOS (Bibliotecas) *)
IMPORT	Gnri, Tipo ;


(*---------------------------------------------------------------------------*)
(* TIPOS *)
TYPE
	Tdatos*	= POINTER TO Treg ;
	Treg*	= RECORD (Gnri.Tgen)
		usuario	: ARRAY Tipo.USU OF CHAR ;
		maquina : ARRAY Tipo.MAQ OF CHAR ;
		archivo : ARRAY Tipo.ARC OF CHAR ;
		cont	: INTEGER ;
	END ;


(*---------------------------------------------------------------------------*)
(* DEFINICION E IMPLEMENTACION DE LOS SUBPROGRAMAS *)
(*-----------------------------------------------------------------------------
   PROCEDIMIENTO crear (SAL datos : Tdatos)
-------------------------------------------------------------------------------
   OBJ		: Crear una estructura
   PRE		: VERDADERO
   POS		: c = Tcaracter
-----------------------------------------------------------------------------*)
PROCEDURE crear* (VAR datos : Tdatos) ;
VAR
	i	: INTEGER ;	(* Contador de posiciones *)
BEGIN
	NEW (datos) ;
	i := 0 ;
	WHILE (i < Tipo.USU - 1) DO
		datos^.usuario[i] := " " ;
		INC (i) ;
	END ;
	datos^.usuario[i] := 0X ;
	i := 0 ;
	WHILE (i < Tipo.MAQ - 1) DO
		datos^.maquina[i] := " " ;
		INC (i) ;
	END ;
	datos^.maquina[i] := 0X ;
	i := 0 ;
	WHILE (i < Tipo.ARC - 1) DO
		datos^.archivo[i] := " " ;
		INC (i) ;
	END ;
	datos^.archivo[i] := 0X ;
	datos^.cont := 0 ;
END	crear ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO obtenerUsu (ENT datos : Tdatos, SAL usuario : ARREGLO DE CARACTER)
-------------------------------------------------------------------------------
   OBJ		: Devuelve el nombre del usuario
   PRE		: datos # NIL
   POS		: usuario = ARRAY OF CHAR
-----------------------------------------------------------------------------*)
PROCEDURE obtenerUsu* (datos : Tdatos ; VAR usuario : ARRAY OF CHAR) ;
VAR
	i	: INTEGER ;	(* Contador de posiciones *)
BEGIN
	ASSERT (datos # NIL) ;
	i := 0 ;
	WHILE (i < Tipo.USU - 1) DO
		usuario[i] := datos^.usuario[i] ;
		INC (i) ;
	END ;
	usuario[i] := 0X ;
END	obtenerUsu ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO obtenerMaq (ENT datos : Tdatos, SAL maquina : ARREGLO DE CARACTER)
-------------------------------------------------------------------------------
   OBJ		: Devuelve el nombre de la maquina
   PRE		: datos # NIL
   POS		: maquina = ARRAY OF CHAR
-----------------------------------------------------------------------------*)
PROCEDURE obtenerMaq* (datos : Tdatos ; VAR maquina : ARRAY OF CHAR) ;
VAR
	i	: INTEGER ;	(* Contador de posiciones *)
BEGIN
	ASSERT (datos # NIL) ;
	i := 0 ;
	WHILE (i < Tipo.MAQ - 1) DO
		maquina[i] := datos^.maquina[i] ;
		INC (i) ;
	END ;
	maquina[i] := 0X ;
END	obtenerMaq ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO obtenerArc (ENT datos : Tdatos, SAL archivo : ARREGLO DE CARACTER)
-------------------------------------------------------------------------------
   OBJ		: Devuelve el nombre del archivo
   PRE		: datos # NIL
   POS		: archivo = ARRAY OF CHAR
-----------------------------------------------------------------------------*)
PROCEDURE obtenerArc* (datos : Tdatos ; VAR archivo : ARRAY OF CHAR) ;
VAR
	i	: INTEGER ;	(* Contador de posiciones *)
BEGIN
	ASSERT (datos # NIL) ;
	i := 0 ;
	WHILE (i < Tipo.ARC - 1) DO
		archivo[i] := datos^.archivo[i] ;
		INC (i) ;
	END ;
	archivo[i] := 0X ;
END	obtenerArc ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO obtenerCon (ENT datos : Tdatos, SAL cont : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Devuelve el contador
   PRE		: datos # NIL
   POS		: cont = INTEGER
-----------------------------------------------------------------------------*)
PROCEDURE obtenerCon* (datos : Tdatos ; VAR cont : INTEGER) ;

BEGIN
	ASSERT (datos # NIL) ;
	cont := datos^.cont ;
END	obtenerCon ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO modificarUsu (ENT/SAL datos : Tdatos, ENT usuario : ARREGLO DE CARACTER)
-------------------------------------------------------------------------------
   OBJ		: Modifica el usuario
   PRE		: datos # NIL, usuario = ARREGLO DE CARACTER
   POS		: obtenerUsu (datos, usuario)
-----------------------------------------------------------------------------*)
PROCEDURE modificarUsu* (VAR datos : Tdatos ; usuario : ARRAY OF CHAR)  ;
VAR
	i	: INTEGER ;	(* Contador de posiciones *)
BEGIN
	ASSERT (datos # NIL) ;
	i := 0 ;
	WHILE (i < Tipo.USU - 1) DO
		datos^.usuario[i] := usuario[i] ;
		INC (i) ;
	END ;
	datos^.usuario[i] := 0X ;
END	modificarUsu ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO modificarMaq (ENT/SAL datos : Tdatos, ENT maquina : ARREGLO DE CARACTER)
-------------------------------------------------------------------------------
   OBJ		: Modifica la maquina
   PRE		: datos # NIL, maquina = ARREGLO DE CARACTER
   POS		: obtenerMaq (datos, maquina)
-----------------------------------------------------------------------------*)
PROCEDURE modificarMaq* (VAR datos : Tdatos ; maquina : ARRAY OF CHAR)  ;
VAR
	i	: INTEGER ;	(* Contador de posiciones *)
BEGIN
	ASSERT (datos # NIL) ;
	i := 0 ;
	WHILE (i < Tipo.MAQ - 1) DO
		datos^.maquina[i] := maquina[i] ;
		INC (i) ;
	END ;
	datos^.maquina[i] := 0X ;
END	modificarMaq ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO modificarArc (ENT/SAL datos : Tdatos, ENT archivo : ARREGLO DE CARACTER)
-------------------------------------------------------------------------------
   OBJ		: Modifica el archivo
   PRE		: datos # NIL, archivo = ARREGLO DE CARACTER
   POS		: obtenerArc (datos, archivo)
-----------------------------------------------------------------------------*)
PROCEDURE modificarArc* (VAR datos : Tdatos ; archivo : ARRAY OF CHAR)  ;
VAR
	i	: INTEGER ;	(* Contador de posiciones *)
BEGIN
	ASSERT (datos # NIL) ;
	i := 0 ;
	WHILE (i < Tipo.ARC - 1) DO
		datos^.archivo[i] := archivo[i] ;
		INC (i) ;
	END ;
	datos^.archivo[i] := 0X ;
END	modificarArc ;


(*-----------------------------------------------------------------------------
   PROCEDIMIENTO modificarCon (ENT/SAL datos : Tdatos, ENT valor : ENTERO)
-------------------------------------------------------------------------------
   OBJ		: Modifica el contador
   PRE		: datos # NIL, valor = ENTERO
   POS		: obtener (datos, valor)
-----------------------------------------------------------------------------*)
PROCEDURE modificarCon* (VAR datos : Tdatos ; valor : INTEGER)  ;

BEGIN
	ASSERT (datos # NIL) ;
	datos^.cont := valor ;
END	modificarCon ;


END	Strc.
